Imports System
Imports System.Data.Entity.Migrations
Imports Microsoft.VisualBasic

Namespace Migrations
    Public Partial Class Initial
        Inherits DbMigration
    
        Public Overrides Sub Up()
            CreateTable(
                "dbo.Categories",
                Function(c) New With
                    {
                        .Id = c.Int(nullable := False, identity := True),
                        .Name = c.String()
                    }) _
                .PrimaryKey(Function(t) t.Id)
            
            CreateTable(
                "dbo.Products",
                Function(c) New With
                    {
                        .Id = c.Int(nullable := False, identity := True),
                        .Name = c.String()
                    }) _
                .PrimaryKey(Function(t) t.Id)
            
            CreateTable(
                "dbo.ProductCategories",
                Function(c) New With
                    {
                        .Product_Id = c.Int(nullable := False),
                        .Category_Id = c.Int(nullable := False)
                    }) _
                .PrimaryKey(Function(t) New With { t.Product_Id, t.Category_Id }) _
                .ForeignKey("dbo.Products", Function(t) t.Product_Id, cascadeDelete := True) _
                .ForeignKey("dbo.Categories", Function(t) t.Category_Id, cascadeDelete := True) _
                .Index(Function(t) t.Product_Id) _
                .Index(Function(t) t.Category_Id)
            
        End Sub
        
        Public Overrides Sub Down()
            DropForeignKey("dbo.ProductCategories", "Category_Id", "dbo.Categories")
            DropForeignKey("dbo.ProductCategories", "Product_Id", "dbo.Products")
            DropIndex("dbo.ProductCategories", New String() { "Category_Id" })
            DropIndex("dbo.ProductCategories", New String() { "Product_Id" })
            DropTable("dbo.ProductCategories")
            DropTable("dbo.Products")
            DropTable("dbo.Categories")
        End Sub
    End Class
End Namespace
