Imports System
Imports System.Data.Entity
Imports System.Data.Entity.Migrations
Imports System.Linq

Namespace Migrations

    Friend NotInheritable Class Configuration
        Inherits DbMigrationsConfiguration(Of Datamodel)

        Public Sub New()
            AutomaticMigrationsEnabled = False
        End Sub

        Protected Overrides Sub Seed(context As Datamodel)
            '  This method will be called after migrating to the latest version.

            '  You can use the DbSet(Of T).AddOrUpdate() helper extension method 
            '  to avoid creating duplicate seed data.

            context.Categories.AddOrUpdate(Function(x) x.Name, New Category With {
                                   .Name = "CategoryA"})
            context.Categories.AddOrUpdate(Function(x) x.Name, New Category With {
                                   .Name = "CategoryB"})
            context.Categories.AddOrUpdate(Function(x) x.Name, New Category With {
                                   .Name = "CategoryC"})

            context.SaveChanges()

            Dim catA = context.Categories.Where(Function(x) x.Name = "CategoryA").FirstOrDefault
            Dim catB = context.Categories.Where(Function(x) x.Name = "CategoryB").FirstOrDefault
            Dim catC = context.Categories.Where(Function(x) x.Name = "CategoryC").FirstOrDefault

            context.Products.AddOrUpdate(Function(x) x.Name, New Product With {
                                         .Name = "Product1"})
            context.Products.AddOrUpdate(Function(x) x.Name, New Product With {
                                         .Name = "Product2"})
            context.Products.AddOrUpdate(Function(x) x.Name, New Product With {
                                         .Name = "Product3"})

            context.SaveChanges()

            Dim prod1 = context.Products.Where(Function(x) x.Name = "Product1").FirstOrDefault
            Dim prod2 = context.Products.Where(Function(x) x.Name = "Product2").FirstOrDefault
            Dim prod3 = context.Products.Where(Function(x) x.Name = "Product3").FirstOrDefault

            prod1.Categories.Add(catA)
            prod2.Categories.Add(catA)
            prod2.Categories.Add(catB)
            prod3.Categories.Add(catA)
            prod3.Categories.Add(catB)
            prod3.Categories.Add(catC)

            context.SaveChanges()

        End Sub

    End Class

End Namespace
