﻿@ModelType IEnumerable(Of SyncFusionChildGridTest.Product)
@Code
    ViewData("Title") = "Index"
End Code

<h2>Index</h2>

<p>
    @Html.ActionLink("Create New", "Create")
</p>

<div class="control-section">
    @code

        Dim productGrid = Html.EJS().Grid("products")

        With productGrid
            .DataSource(Model.Products)

            Dim colsList As New List(Of Grids.GridColumn)


            Dim colId = New Grids.GridColumn
            colId.Field = "Id"
            colId.HeaderText = "Product Id"
            colId.TextAlign = Grids.TextAlign.Right
            colId.Visible = False
            colsList.Add(colId)


            Dim colName As Grids.GridColumn = New Grids.GridColumn
            colName.Field = "Name"
            colName.HeaderText = "Naam"
            colName.Template = "#productNameTemplate"
            colsList.Add(colName)


            Dim colActive As Grids.GridColumn = New Grids.GridColumn
            colActive.Field = "Active"
            colActive.HeaderText = "Status"
            colActive.Template = "#statusTemplate"
            colActive.Filter = New With {.type = "CheckBox", .itemTemplate = "#StatusItemTemp"}
            colsList.Add(colActive)



            .Columns(colsList)
            .AllowPaging()
            .PageSettings(Sub(page)
                              page.PageSize(10)
                              page.PageSizes(True)
                          End Sub)
            .AllowSorting()
            .AllowGrouping()
            .AllowFiltering()

            Dim filtersetting As New Grids.GridFilterSettings

            filtersetting.Mode = Grids.FilterBarMode.Immediate
            filtersetting.ImmediateModeDelay = 1000

            .FilterSettings(filtersetting)
            .Toolbar(New List(Of String) From {"Search"})

            .QueryCellInfo("queryCellInfo")
            .RecordDoubleClick("recordDoubleClick")

        End With


        Dim categoryGrid = Html.EJS().Grid("categories")

        With categoryGrid
            .DataSource(Model.ProductCategories)
            .Columns(Sub(col)
                         col.Field("Id").HeaderText("ID").TextAlign(TextAlign.Right).Add()
                         col.Field("Product_Id").HeaderText("Product_Id").Add()
                     End Sub)
            .AllowPaging()
            .QueryString("Product_Id")
            .Height(200)


        End With

    End Code
    <div class="gridCategories">@categoryGrid.Render()</div>

    @*@productGrid.ChildGrid(categoryGrid)*@
    <div class="gridProducts">@productGrid.Render()</div>
</div>